<?php
	/*

	Plugin Name:    Photos Flickr
	Plugin URI:     http://dannyman.toldme.com/photos-flickr/

	Author:         Danny Howard
	Author URI:     http://dannyman.toldme.com/

	Description:    Photos Flickr is an early version of a plugin that I am developing for WordPress blog software to display a user's Flickr album within their blog.  This plugin is far from fully-baked.  It does some of what I want, so far, and there is more work to do.

	Version:        0.6

	*/

	// require_once("photos-flickr-conf.php");
	require_once("phpFlickr/phpFlickr.php");

    // CONFIGURATION -- From photos-flickr-conf.php
	/* pretty obvious */
	$flickr_user    =   get_option('flickr_user');
	/* Get one at http://www.flickr.com/services/api/key.gne */
	$flickr_API_key =   'efc050ee72d23be84595fcf05995ebf6';

	/* Enable database-backed cache.  These defaults should "just work"
	* but if things get broken, try commenting out the following lines.
    *
    * TODO: Configurability-via-admin?
	* */
	$flickr_cache_db    = "mysql://".DB_USER.":".DB_PASSWORD."@".DB_HOST."/".DB_NAME;
	$flickr_cache_exp   = '600';
	$flickr_cache_table = $GLOBALS['table_prefix']."flickr_cache";

    // well, if we have to . . .
    // $debug = True;

	// set by photos_init()
	$f;                 // phpFlickr object -- API handle
    $person;            // findByUsername is supposed to return NSID, but ...
    $nsid;              // NSID (UID) on Flickr
    $photos_base_url;   // So we can get self-referential
    // CONTEXT
    $context    = 'index'; // index OR photo OR set OR tag ...
    $photo_id; $photoset_id; $tag;
    $page       = 1;
    $index_type = 'photo';

    // other globals
    $error_message;     // In case we want to flash the user / admin

    /*
    PUBLIC: photos_init -- MANDATORY call once before you call other
    stuff:
    - Connects to Flickr, setting up phpFlickr handle ($f)
    - Connects to cache database
    - Sets up $person and $nsid for our convenience
    - Sets up $photos_base_url appropriately

    TODO: If we are hooking in to WordPress' init() then this should
    check to see if we're actually doing any photos before it goes
    pinging Flickr and setting up a database connection, huh?

    */
	function photos_init() {
        global $f, $person, $nsid, $photos_base_url;
        global $flickr_user, $flickr_API_key;
        global $flickr_cache_db, $flickr_cache_exp, $flickr_cache_table;
        global $context, $photo_id, $photoset_id, $tag, $page, $index_type;
        global $init_done; // Careful not to overdo it.
        // Connects to Flickr, setting up phpFlickr handle ($f)
		photos_init_phpFlickr();
		// Sets up $person and $nsid for our convenience
		// $person = $f->people_findByUsername($GLOBALS['flickr_user']);
		$person = get_flickr_user($f, $flickr_user);
        // WTF: findByUsername used to return NSID directly.
		$nsid = $person['id'];
        // Establish context: index, set, tag, or none
        // Populate from $_REQUEST ... this may need to be broken into
        // its own function.
        if( $_REQUEST['photo'] ) {
            $photo_id = $_REQUEST['photo'];
        }
        else { // photo or index of what?  (photos, by default)
            if( $_REQUEST['index']  ) {
                $index_type = $_REQUEST['index'];
            }
            else {
                $index_type = 'photo';
            }
        }
        if( $_REQUEST['photoset'] ) {
            $context = 'photoset';
            $photoset_id = $_REQUEST['photoset'];
        }
        if( $_REQUEST['tag'] ) {
            $context = 'tag';
            $tag = $_REQUEST['tag'];
        }
		if( $_REQUEST['page'] ) {
            $page = $_REQUEST['page'];
        }
        // Sets up $photos_base_url appropriately
        // TODO: This should be configurable?
        $photos_base_url = get_permalink();
        // /?page_id=3 -> /?page_id=3&  . . . /photos/ -> /photos/?
        if( strstr($photos_base_url, '?') ) { $photos_base_url .= '&'; }
        else { $photos_base_url .= '?'; }
        whine("photos_base_url: $photos_base_url");
	}
    // wp_head is far anough to build $photos_base_url
    // BUT this is somewhat silly.
    // add_action('wp_head', 'photos_init');

    // photos_init_phpFlickr -- connects to Flickr, setting up $f
    function photos_init_phpFlickr() {
        global $f, $flickr_API_key;
        global $flickr_cache_db, $flickr_cache_exp, $flickr_cache_table;
        if( $f ) { return; } // Why reinvent the $f?
        $f = new phpFlickr($flickr_API_key);
        // Connects to cache database
		if( $flickr_cache_db ) {
			$f->enableCache('db', $flickr_cache_db,
				$flickr_cache_exp, $flickr_cache_table);
		}
    }

    /*
    PRIVATE: photos_config_page -- Hooks into WordPress Admin menu to
    manage options and whatnot.
    */
    function photos_config_page() {
        global $flickr_user, $flickr_API_key;
        global $flickr_cache_db, $flickr_cache_exp, $flickr_cache_table;

        // Add submenu to Plugins tab: Photos Flickr
        add_submenu_page('plugins.php',
            'Photos Flickr', 'Photos Flickr', 'manage_options',
            'photos-flickr-config', 'photos_flickr_config_page');
    }
    add_action('admin_menu', 'photos_config_page');

    /*
    PRIVATE: get_flickr_user -- private function to map NSID, username,
    or e-mail to $flickr_user, which will be an NSID.

    Meant to be called by init() as a convenience and also by the Admin
    panel as a sanity-check.

    Returns a $person ... I think.
    */
    function get_flickr_user( $f, $get_flickr_user ) {
        global $error_message;
        // DEFAULT: admin_email
        if( !$get_flickr_user ) {
            $get_flickr_user = get_option('admin_email');
        }
        if( !$get_flickr_user ) {
            $error_message .= "get_flickr_user: I don't think this ".
            "request is true: '$get_flickr_user'!";
            return(False);
        }
        if( $debug ) { echo "Looking for get_flickr_user == $get_flickr_user<br />"; }
        // CASE 1: Valid NSID
        $get_person = $f->people_getInfo($get_flickr_user);
        if( isset($get_person['id']) ) { 
            if( $debug ) { echo "get_flickr_user--NSID: ".$get_person['id']."<br />"; }
            return($get_person);
        }
        // CASE 2: Valid username
        $get_person = $f->people_findByUsername($get_flickr_user);
        if( isset($get_person['id']) ) { 
            if( $debug ) { echo "get_flickr_user--Username: ".$get_person['id']."<br />"; }
            return($get_person);
        }
        // CASE 3: Valid e-mail
        $get_person = $f->people_findByEmail($get_flickr_user);
        if( isset($get_person['id']) ) { 
            if( $debug ) { echo "get_flickr_user--Email: ".$get_person['id']."<br />"; }
            return($get_person);
        }
        // CASE 4: Nyet!
        $error_message .= "get_flickr_user: I tried to search by ".
            "NSID, username, and e-mail, but found nothing for ".
            "'$get_flickr_user'!";
        return(False);
    }

    /*
    PRIVATE: photos_flickr_config_page -- Displays the actual
    administrative configuration page.  Byagh!
    */
    function photos_flickr_config_page() {
    /* WTF: Stolen heavily from the Akismet plugin, which lacks
     * comments, so who knows what the f_ck I'm doing wrong here? */
        global $flickr_API_key, $flickr_user;
        global $f;
        global $error_message;

    // STEP 2: Parse form submissions
    // TODO: Do we need to check user authentication level!?
    if ( isset($_POST['submit']) ) {
        photos_init_phpFlickr();
        if( isset($_POST['flickr_API_key']) ) {
            $flickr_API_key = $_POST['flickr_API_key'];
            update_option('flickr_API_key', $flickr_API_key);
        }
        if( isset($_POST['flickr_user']) ) {
            $person = get_flickr_user( $f, $_POST['flickr_user'] );
            if( $person ) {
                $flickr_user = $person['id'];
                update_option('flickr_user', $flickr_user);
            }
        }
    }

    // STEP 1: Build a form ...
?>
<?php if ( !empty($_POST)  && empty($error_message) ) : ?>
<div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div>
<?php elseif ( !empty($_POST) && !empty($error_message) ) : ?>
<div id="message" class="error"><p><strong><?php _e($error_message) ?></strong></p></div>
<?php endif; ?>
<div class="wrap">
    <h2>Photos Flickr</h2>
    <form action="" method="post" id="photos-flickr-config">
        <table class="optiontable">
            <tr valign="top">
                <th scope="row">Flickr User ID:</th>
                <td><input name="flickr_user" type="text"
                value="<?php echo "$flickr_user" ?>" />
                <br />Enter your NSID, Flickr screen name, or the e-mail
                address you used to register with Flickr.  Once found,
                this value will be converted to your NSID.  If you don't
                enter anything, we will try your
                <code>admin_email</code>.</td>
            </tr>
            <tr valign="top">
                <th scope="row">Flickr API Key:</th>
                <td><input name="flickr_API_key" type="text" size="32"
                class="code" value="<?php echo "$flickr_API_key" ?>" />
                <br /><b>Required!</b>  You will need to <a
                href="http://www.flickr.com/services/api/keys/apply/">request
                an API key from flickr.com</a> for this plugin to
                work.</td>
            </tr>
        </table>
    <p class="submit"><input type="submit" name="submit" value="Update Options &raquo;" /></p>
    </form>
</div>
<?php
;
    }

	// PUBLIC: "Hello World" function -- useful for testing
	function photos_flickr_hello() {
		// Bring in our flickr object and NSID
		$f = $GLOBALS['f'];
		$nsid = $GLOBALS['nsid'];
        if( $debug ) { print "nsid: $nsid<br />\n"; }
	
	    // Get the friendly URL of the user's photos
	    $photos_url = $f->urls_getUserPhotos($nsid);
        if( $debug ) { print "photos_url: $photos_url<br />\n"; }
   
	    // Get the user's first 36 public photos
		$photos = $f->people_getPublicPhotos($nsid, NULL, 36);
   
	    // Loop through the photos and output the html
	    foreach ((array)$photos['photo'] as $photo) {
			print "<a href=$photos_url$photo[id]>";
	        print "<img border='0' ". // alt='$photo[title]' ".
				"src=" . $f->buildPhotoURL($photo, "Square") . ">";
	        print "</a>";
			$i++;
			// If it reaches the sixth photo, insert a line break
			if ($i % 6 == 0) {
				echo "<br>\n";
	     	}
		}
	}

    // PUBLIC: Print a link to index page
    function photos_index_href() {
//        global $photos_base_url;
//        print $photos_base_url;
        print get_permalink();
    }

    // PUBLIC: Print a link to index page
    function photos_photo_index_href() {
//        global $photos_base_url;
//        print $photos_base_url;
        print get_permalink();
    }

    // PUBLIC: Print a link to index page
    function photos_photoset_index_href() {
        global $photos_base_url;
        print $photos_base_url."index=photoset";
    }

    /*
    PUBLIC: PRETTY: photos_photoset_index -- Print a reasonable photoset
    index.

    Arguments:
        $num_per_row    = number of sets to print between $row_sep
        $row_sep        = what to print between rows
        $print_thumb    = print thumbnail?  Unless NULL, what kind?
        $print_title    = print title?
        $print_count    = print count?
        $photoset_before = what to print before photoset
        $photoset_after = what to print after photoset
        $thumb_before   = what to print before thumbnail
        $thumb_after    = what to print after thumbnail
        $title_before   = what to print before title
        $title_after    = what to print after title
        $count_before   = what to print before count
        $count_after    = what to print after count

    We call it $context_id in the hope that we could one day give context for,
    say, tags ...
    */
	function photos_photoset_index(
      $num_per_row = 6, $row_sep = '<br />',
      $print_thumb='square', $print_title = true, $print_count = NULL,
      $photoset_before = '<div style="float: left; width: 85px; height: 170px;">',
      $photoset_after='</div>',
      $thumb_before = '', $thumb_after= '',
      $title_before = '<br />', $title_after='',
      $count_before = '<br />', $count_after = ' photos'
    ) {
        global $f, $nsid;
        $my_photosets = $f->photosets_getList($nsid);
        foreach( (array)$my_photosets['photoset'] as $my_photoset ) {
            // vars
            $my_count = $my_photoset['photos'];
            $my_id = $my_photoset['id'];
            $my_primary = $my_photoset['primary'];
            $my_title = $my_photoset['title'];
            // divide-by-zero
            if(! $num_per_row ) { $num_per_row = 1; }
            // printy
            print $photoset_before;
            if( $print_thumb ) {
                // tricky: make a "photo" that we can pass to
                // PHPFlickr's buildPhotoURL ...
                $my_thumb = $my_photoset;
                // "primary" references the photoset's "primary image"
                $my_thumb['id'] = $my_photoset['primary'];
                print "<!-- id: $my_id primary: $my_primary ".
                  "print_thumb: $print_thumb -->";
                print $thumb_before.
                  "<a href=\"";photos_photoset_href($my_id);print"\">".
                  "<img class=\"photosetThumb\" ".
				  " src=\"".$f->buildPhotoURL($my_thumb, $print_thumb).
                  "\" />".
                  "</a>".$thumb_after;
            }
            if( $print_title ) {
                print "$title_before".
                  "<a href=\"";photos_photoset_href($my_id);print"\">".
                  "$my_title</a>$title_after";
            }
            if( $print_count ) {
                print "$count_before$my_count$count_after";
            }
            print $photoset_after."\n";
			$i++;
			if( $i%$num_per_row == 0 ) {
				print $row_sep."\n";
			}
        }
    }

	// PUBLIC: Print a reasonable photo index.
	function photos_photo_index(
		$num_per_page = 25, $num_per_row = 5, $page = NULL,
		$thumb_type='square', $thumb_before = '', $thumb_after = '',
		$row_sep = '<br />' ) {
        global $context, $tag, $photoset_id, $page;
        global $f, $nsid, $photos_base_url;
        global $debug;

        if( $context == "photoset" ) {
        // http://www.flickr.com/services/api/flickr.photosets.getPhotos.html
            $photos = $f->photosets_getPhotos($photoset_id, NULL, NULL,
                $num_per_page, $page);
        } elseif( $context == "tag" ) {
        // http://www.flickr.com/services/api/flickr.photos.search.html
			$photos = $f->photos_search(array("user_id"=>$nsid,
				"tags"=>$tag, "per_page"=>$num_per_page,
				"page"=>$page));
		} else {
        // http://www.flickr.com/services/api/flickr.people.getPublicPhotos.html
			$photos = $f->people_getPublicPhotos($nsid, NULL,
				$num_per_page, $page);
		}

		foreach ((array)$photos['photo'] as $photo) {
			print $thumb_before .
				"<a href=\"".$photos_base_url;
            if( $context == "photoset" ) { print "photoset=$photoset_id&"; }
            print "photo=$photo[id]\">" .
				"<img class=\"photosThumb\" id=\"photosId_$photo[id]\"" .
				// " alt=\"$photo[title]\" title=\"$photo[title]\"" .
				" src=\"".$f->buildPhotoURL($photo, $thumb_type)."\" />" .
				"</a>" .
				$thumb_after."\n";
			$i++;
			if( $i%$num_per_row == 0 ) {
				print $row_sep."\n";
			}
		}
	}
    // DEPRECATED: Backward compatability
	function photos_index(
		$num_per_page = 25, $num_per_row = 5, $page = NULL,
		$thumb_type='square', $thumb_before = '', $thumb_after = '',
		$row_sep = '<br />' ) {
        photos_photo_index($num_per_page, $num_per_row, $page,
          $thumb_type, $thumb_before, $thumb_after, $row_sep);
    }

	// PUBLIC: Print "paginate" link bar thingy
	function photos_photo_pageindex( $context = 2, $num_per_page = 25,
		$item_sep = ', ', $dotdotdot = " . . . ",$page = NULL ) {

        global $tag, $photoset_id;
        // This conflict was fun to puzzle over!  =D
        $global_context = $GLOBALS['context'];
        if( $debug ) { echo "global_context: $global_context"; }
		// Bring in our flickr object and NSID
        global $f, $nsid, $photos_base_url;
        global $debug;
		// $f = $GLOBALS['f'];
		// $nsid = $GLOBALS['nsid'];
        // $photos_base_url = $GLOBALS['photos_base_url'];
		// IF no page is passed, check $_REQUEST, else set to 1
		if( $page == NULL ) {
			if( $_REQUEST['page'] ) { $page = $_REQUEST['page']; }
			else                    { $page = 1; }
		}

		// Count the number of pages ...
        if( $global_context == "photoset" ) {
            $photos = $f->photosets_getPhotos($photoset_id, NULL, NULL,
                $num_per_page, $page);
        } elseif( $global_context == "tag" ) {
			$photos = $f->photos_search(array("user_id"=>$nsid,
				"tags"=>$tag, "per_page"=>$num_per_page,
				"page"=>$page));
		} else {
			$photos = $f->people_getPublicPhotos($nsid, NULL,
				$num_per_page, $page);
		}
		$pagecount = $photos['pages'];
        whine("pagecount: $pagecount");

        // emit means "print a comma"
		$n = 1; $emit = 0; $printme = '';
		while( $n <= $pagecount ) {
            // DO print numeric links
			if( 
                // 1, 2, 3 ...
				( 1 <= $n && $n <= (1+$context) )                    ||
				// ... 7, 8, [9], 10, 11 ...
				( ($page-$context) <= $n && $n <= ($page+$context) ) ||
				// ... 98, 99, 100
				( ($pagecount-$context) <= $n && $n <= $pagecount ) ) {
                // print a comma?
       			if( $emit != 0 ) { print $item_sep; $emit = 0; }
    			if( $n == $page ) { // CURRENT page number
    				print "<b>$n</b>";
    			} else {            // LINK page number
                    if( $global_context == "photoset" ) {
    					print "<a href=\"".$photos_base_url.
    						"photoset=$photoset_id&page=$n\">$n</a>";
                    } elseif ( $global_context == "tag" ) {
    					print "<a href=\"".$photos_base_url.
    						"tag=$tag&page=$n\">$n</a>";
    				} else {
    					print "<a href=\"".$photos_base_url.
    						"page=$n\">$n</a>";
    				}
    			}
    			$emit++;
            // DO NOT print numeric links
        }
            else if( $emit != 0 ) { print $dotdotdot; $emit = 0; }
    		$n++;
        }
    }
    // DEPRECATED: Backward compatability
	function photos_pageindex( $context = 2, $num_per_page = 25,
		$item_sep = ', ', $dotdotdot = " . . . ",$page = NULL ) {
        photos_photo_pageindex($context, $num_per_page, $item_sep,
          $dotdotdot, $page);
    }

    /*
        WELCOME TO SECTION PUBLIC: BASIC: photo
        TODO: photos_photo_list();
        photos_photo_description();
        TODO: photos_photo_href();
        photos_photo_title();
        photos_photo_url();

        photos_photo_photoset_list();
        photos_photo_tag_list();

    */

    // PUBLIC: BASIC: photo: photos_photo_description -- Print photo
    // information - description
	function photos_photo_description( $photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
		// Bring in our flickr object
		$f = $GLOBALS['f'];

		$photo = $f->photos_getInfo($photo_id);
		$description = str_replace("\n", '<br />', $photo[description]);
		print $description;
	}

    // PUBLIC: BASIC: photo: photos_photo_title -- Print photo information -
    // title
	function photos_photo_title( $photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
		// Bring in our flickr object
		$f = $GLOBALS['f'];

		$photo = $f->photos_getInfo($photo_id);
		print $photo[title];
	}

    // PUBLIC: BASIC: photo: photos_photo_url -- Print photo information -
    // URL
	function photos_photo_url( $size='medium', $photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
		// Bring in our flickr object
		$f = $GLOBALS['f'];

		$photo = $f->photos_getInfo($photo_id);
		print $f->buildPhotoURL($photo, $size);
	}

	/*
    PUBLIC: BASIC: photo: photos_photo_photoset_list -- Return a list of
    photosets associated with $photo_id.

    Returns False if no photosets.
    */
    function photos_photo_photoset_list( $photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
        return photos_photoset_list($photo_id);
    }

	/*
    PUBLIC: BASIC: photo: photos_photo_tag_list -- Return a list of tags
    associated with $photo_id.

    Returns False if no tags.
    */
	function photos_photo_tag_list( $photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
        // Get $photo ...
		global $f;
		$photo = $f->photos_getInfo($photo_id);

		if( $photo['tags'] ) {
            // $my_tags = $photo['tags']['tag'];
			// foreach( $my_tags as &$my_tag ) {
            //     $my_tag = $my_tag['raw'];
            // }
            // return $my_tags;
			return $photo['tags']['tag'];
		} else {
            return(False);
        }
	}

	// PUBLIC: Print linked tags for a photo
	function photos_photo_tags( $tag_before = '', $tag_after = ' ',
		$photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
		// Bring in our flickr object
		$f = $GLOBALS['f'];
        // So we can build our HREF action!
        $photos_base_url = $GLOBALS['photos_base_url'];

        // Get $photo ...
		$photo = $f->photos_getInfo($photo_id);

		if( $photo['tags'] ) {
            $length = count($photo['tags']['tag']);
			foreach( $photo['tags']['tag'] as $tag ) { $i++;
			    print "$tag_before<a href=\"".$photos_base_url.
                    "tag=$tag[_content]\">$tag[raw]</a>";
                if( $i < $length ) print $tag_after;
			}
		}
	}

	// PUBLIC: Print photo information - photopage URL
	function photos_photo_page_url( $photo_id = NULL ) {
        global $person;
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
		print "http://www.flickr.com/photos/".
			$person['username']."/".$photo_id."/";
	}

    // PUBLIC: photo_photo_date_taken - prints date a photo was taken
    function photos_photo_date_taken( $photo_id = NULL, 
      $date_format = NULL ) {
        if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
        // Hey, we set this default somewhere in the WP admin, neh?
        if( $date_format == NULL ) { $date_format = get_option('date_format'); }
        // get busy -- get $f!
        global $f;
        $photo = $f->photos_getInfo($photo_id);
        if( $date_format == NULL ) { // Why bother?
            print $photo[dates][taken];
        } else {                    // If you insist ...
            /* We get something like:
                2007-05-22 01:31:15
                0123456789012345678
                0         1
                That's why the stdlib invented substr():
                http://us.php.net/manual/en/function.substr.php
                We need to feed the mktime():
                hour, minute, second, month, day, year
                http://us.php.net/manual/en/function.mktime.php */
            $my_dates_taken = $photo[dates][taken];
            $my_hour = substr($my_dates_taken, 11, 2);
            $my_min = substr($my_dates_taken, 14, 2);
            $my_sec = substr($my_dates_taken, 17, 2);
            $my_mon = substr($my_dates_taken, 5, 2);
            $my_day = substr($my_dates_taken, 8, 2);
            $my_year = substr($my_dates_taken, 0, 4);
            $my_timestamp = mktime($my_hour, $my_min, $my_sec,
              $my_mon, $my_day, $my_year);
            print date($date_format, $my_timestamp);
        }
    }

    /*
    PRIVATE: photos_private_getContext -- "MASTER" function for:
    photos_(photo|photoset)_(next|prev)_(href|url|title)

    Arguments:
        $context    = (photo|photoset)
        $nl         = (next|prev)
        $attr       = (href|url|title)
        $photo_id   = photo ID for context
        $context_id = set ID for context
        $thumb_type = thumbnail type for url

    We call it $context_id in the hope that we could one day give context for,
    say, tags ...
    */
    function photos_private_getContext(
      $context = NULL, $nl = NULL, $attr = NULL,
      $photo_id = NULL, $context_id = NULL, $thumb_type = 'square' ) {
        global $f, $photos_base_url;
        // There's no context without $photo_id ...
        if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
        // There's no context without $photoset_id ...
        if( $photoset_id == NULL ) { $photoset_id = $GLOBALS['photoset_id']; }
        // "nextphoto" or "prevphoto"
        $nlphoto = $nl."photo";
        // return string
        $my_return = NULL;

        // First, look at our context
        if( $context == "photoset" ) {
            $my_gotContext = $f->photosets_getContext($photo_id, $context_id);
            $my_photos_base_url = $photos_base_url."photoset=$context_id&";
        } else { // default to context == "photo"
            $my_gotContext = $f->photos_getContext($photo_id);
            $my_photos_base_url = $photos_base_url;
        }
        // Assign my_c_photo_id to the appropriate neighbor
        // "context photo id"
        $my_c_photo_id = $my_gotContext[$nlphoto][id];
        if( $my_c_photo_id != 0 ) { // if exists us
            if( $attr == "href" ) {
    			$my_return = $my_photos_base_url."photo=".$my_c_photo_id;
            }
            elseif( $attr == "title" ) {
    			$my_return = $my_gotContext[$nlphoto]['title'];
            }
            elseif( $attr == "url" ) {
                // We work with my "context" photo
                $my_c_photo = $f->photos_getInfo($my_c_photo_id);
			    $my_return = "<img class=\"photosThumb\" id=\"photosId_".
				  $my_c_photo_id."\" src=\"".
				  $f->buildPhotoURL($my_c_photo, $thumb_type).
				  // "\" title=\"".$my_gotContext[$nlphoto]['title'].
                  "\" />";
            }
        }
        return $my_return;
    }

	// PUBLIC: Print next photo thumbnail
	function photos_photo_next_url( $thumb_type = 'square',
      $photo_id = NULL ) {
        print photos_private_getContext("photo", "next", "url",
          $photo_id, NULL, $thumb_type);
	}

	// PUBLIC: Print prev photo thumbnail
	function photos_photo_prev_url( $thumb_type = 'square',
      $photo_id = NULL ) {
        print photos_private_getContext("photo", "prev", "url",
          $photo_id, NULL, $thumb_type);
	}

	// PUBLIC: Print next photo href
	function photos_photo_next_href( $photo_id = NULL ) {
        print photos_private_getContext("photo", "next", "href", $photo_id);
	}

	// PUBLIC: Print prev photo href
	function photos_photo_prev_href( $photo_id = NULL ) {
        print photos_private_getContext("photo", "prev", "href", $photo_id);
	}

	// PUBLIC: Print next photo title
	function photos_photo_next_title( $photo_id = NULL ) {
        print photos_private_getContext("photo", "next", "title", $photo_id);
	}

	// PUBLIC: Print prev photo title
	function photos_photo_prev_title( $photo_id = NULL ) {
        print photos_private_getContext("photo", "prev", "title", $photo_id);
	}

    /*
        WELCOME TO SECTION PUBLIC: BASIC: photoset
        photos_photoset_list();
        photos_photoset_description();
        photos_photoset_href();
        photos_photoset_title();
        photos_photoset_url();
    */

    /*
    PUBLIC: BASIC: photosets: photos_photoset_list() -- Return a list of
    associated with $photo_id.

    Defaults to returning a list of all sets for user.
    Returns False if no photosets.
    */
	function photos_photoset_list( $photo_id = NULL ) {
        global $f, $nsid;

        if( $photo_id ) {
            // Get a list of sets for this photo
    		$my_contexts = $f->photos_getAllContexts($photo_id);
            // $my_context == array of <set /> tags with keys for id, title
            if( $my_contexts['set'] ) {
                foreach( $my_contexts['set'] as $my_context ) {
                    $my_return[] = $my_context['id'];
                }
            }
        } else {
            // Get a list of sets for this user
            $my_photosets = $f->photosets_getList($nsid);
            // $my_photosets == array of <photoset /> tags with keys for id,
            // title, description
            if( $my_photosets['photoset'] ) {
                foreach( $my_photosets['photoset'] as $my_photoset ) {
                    $my_return[] = $my_photoset['id'];
                }
            }
        }

        if( $my_return ) { return $my_return; }
        // else
        return False;
	}

    /*
    PUBLIC: BASIC: photosets: photos_photoset_description() -- Print
    Description of $photoset_id.
    */
    function photos_photoset_description( $photoset_id = NULL ) {
        if( $photoset_id == NULL ) { $photoset_id = $GLOBALS['photoset_id']; }
        global $f;
		$set = $f->photosets_getInfo($photoset_id);
		$description = str_replace("\n", '<br />', $set[description]);
		print $description;
    }

    /*
    PUBLIC: BASIC: photosets: photos_photoset_href() -- Print URL for index
    page for $photoset_id.
    */
    function photos_photoset_href( $photoset_id = NULL ) {
        if( $photoset_id == NULL ) { $photoset_id = $GLOBALS['photoset_id']; }
		global $photos_base_url;
        print $photos_base_url."photoset=".$photoset_id;
    }

    /*
    PUBLIC: BASIC: photosets: photos_photoset_title() -- Print
    Title of $photoset_id.
    */
    function photos_photoset_title( $photoset_id = NULL ) {
        if( $photoset_id == NULL ) { $photoset_id = $GLOBALS['photoset_id']; }
        global $f;
		$set = $f->photosets_getInfo($photoset_id);
		print $set[title];
    }

    /*
    PUBLIC: BASIC: photosets: photos_photoset_url() -- Print
    Title of $photoset_id.
    */
    function photos_photoset_url( $photoset_id = NULL, $thumb_type = 'square' ) {
        if( $photoset_id == NULL ) { $photoset_id = $GLOBALS['photoset_id']; }
        global $f;
		$set = $f->photosets_getInfo($photoset_id);
        $my_primary_id = $set['primary'];
        // Now we need to getInfo($my_primary_id)
		$my_primary_photo = $f->photos_getInfo($my_primary_id);
        print "<img class=\"photosThumb\" id=\"photosId_".
				  $my_primary_id."\" src=\"".
				  $f->buildPhotoURL($my_primary_photo, $thumb_type).
				  // "\" title=\"".$my_primary_photo['title'].
                  "\" />";
    }

	// PUBLIC: Print next photoset thumbnail
	function photos_photoset_next_url( $photoset_id = NULL, $thumb_type = 'square',
      $photo_id = NULL ) {
        print photos_private_getContext("photoset", "next", "url",
          $photo_id, $photoset_id, $thumb_type);
	}

	// PUBLIC: Print prev photoset thumbnail
	function photos_photoset_prev_url( $photoset_id = NULL, $thumb_type = 'square',
      $photo_id = NULL ) {
        print photos_private_getContext("photoset", "prev", "url",
          $photo_id, $photoset_id, $thumb_type);
	}

	// PUBLIC: Print next photoset href
	function photos_photoset_next_href( $photoset_id = NULL, $photo_id = NULL ) {
        print photos_private_getContext("photoset", "next", "href",
          $photo_id, $photoset_id);
	}

	// PUBLIC: Print prev photoset href
	function photos_photoset_prev_href( $photoset_id = NULL, $photo_id = NULL ) {
        print photos_private_getContext("photoset", "prev", "href",
          $photo_id, $photoset_id);
	}

	// PUBLIC: Print next photoset title
	function photos_photoset_next_title( $photoset_id = NULL, $photo_id = NULL ) {
        print photos_private_getContext("photoset", "next", "title",
          $photo_id, $photoset_id);
	}

	// PUBLIC: Print prev photoset title
	function photos_photoset_prev_title( $photoset_id = NULL, $photo_id = NULL ) {
        print photos_private_getContext("photoset", "prev", "title",
          $photo_id, $photoset_id);
	}

    /*
    PUBLIC: PRETTY: photos_photo_photosets() -- Print linked photosets for a
    photo.
    */
    function photos_photo_photosets(
      $photoset_before = '', $photoset_after = ' ', $photo_id = NULL ) {
		if( $photo_id == NULL ) { $photo_id = $GLOBALS['photo_id']; }
		// Bring in our flickr object
		global $f, $photos_base_url;
        // Get $photo ...
		$photo = $f->photos_getAllContexts($photo_id);

            // Get a list of sets for this photo
    		$my_contexts = $f->photos_getAllContexts($photo_id);
            // $my_context == array of <set /> tags with keys for id, title
            foreach( $my_contexts['set'] as $my_context ) {
                $my_return[] = $my_context['id'];
            }

		if( $photo['set'] ) {
            $length = count($photo['set']);
			foreach( $photo['set'] as $set ) { $i++;
			    print "$photoset_before<a href=\"".$photos_base_url.
                    "photoset=$set[id]\">$set[title]</a>";
                if( $i < $length ) print $photoset_after;
			}
		}
	}

	// PUBLIC: Are we a page for one photo, or some nav index?
	function is_photo() {
        global $photo_id;
        // I wonder if this isn't the same as: return $photo_id;
        if( $photo_id ) { return $photo_id; } else { return false; }
	}

	// PUBLIC: Are we an index page?  If so, what flavor?
	function is_index() {
        global $index_type;
        if( is_photo() == false && $index_type ) {
            return $index_type;
        }
        else {
            return false;
        }
	}

    // PRIVATE: Collect debug messages
    function whine($message = "but i don't know why!") {
        global $debug;
        if( $debug ) { echo "$message<br />"; }
    }

?>
